test_name "CVE-2013-3567 Arbitrary YAML Deserialization"

reportdir = create_tmpdir_for_user master, 'yaml_deserialization'

dangerous_yaml = "--- !ruby/object:Puppet::Transaction::Report { metrics: { resources: !ruby/object:ERB { src: 'exit 0' } }, logs: [], resource_statuses: [], host: '$(puppet master --configprint certname)' }"

submit_bad_yaml = [
  "curl --tlsv1 -k -X PUT",
  "--cacert $(puppet master --configprint cacert)",
  "--cert $(puppet master --configprint hostcert)",
  "--key $(puppet master --configprint hostprivkey)",
  "-H 'Content-Type: text/yaml'",
  "-d \"#{dangerous_yaml}\"",
  "\"https://#{master}:8140/production/report/$(puppet master --configprint certname)\""
].join(' ')

master_opts = {
  'master' => {
    'reportdir' => reportdir,
    'reports' => 'store',
  }
}

# In PE, the master is running as non-root. We need to set the
# reportdir permissions correctly for it.
on master, "chmod 750 #{reportdir}"
if options.is_pe?
  on master, "chown pe-puppet:pe-puppet #{reportdir}"
elsif master.is_using_passenger?
  on master, "chown puppet:puppet #{reportdir}"
end

with_puppet_running_on(master, master_opts) do
  on master, submit_bad_yaml
  on master, "cat #{reportdir}/$(puppet master --configprint certname)/*" do
    assert_no_match(/ERB/, stdout, "Improperly propagated ERB object from input into puppet code")
  end
end

on master, "rm -rf #{reportdir}"
