test_name "CVE-2013-3567 Arbitrary YAML Query Parameter Deserialization"

CURL_UNABLE_TO_FETCH_PAGE = 22

require 'uri'

dangerous_yaml = "--- !ruby/object:Puppet::Node::Environment { name: 'manage' }"

submit_bad_yaml_as_parameter = [
  "curl --tlsv1 -f -s -S -k -X GET",
  "--cacert $(puppet master --configprint cacert)",
  "--cert $(puppet master --configprint hostcert)",
  "--key $(puppet master --configprint hostprivkey)",
  "-H 'Accept: yaml'",
  "\"https://#{master}:8140/production/file_metadata/modules/testing/tested?links=#{URI.encode(dangerous_yaml)}\""
].join(' ')


modules = master.tmpdir('modules')
apply_manifest_on master, <<MANIFEST
   file { "#{modules}": ensure => directory, owner => puppet }
-> file { "#{modules}/testing": ensure => directory, owner => puppet }
-> file { "#{modules}/testing/files": ensure => directory, owner => puppet }
-> file { "#{modules}/testing/files/tested": ensure => file, content => "test", owner => puppet }
MANIFEST

master_opts = {
  'master' => {
    'modulepath' => modules,
  }
}

with_puppet_running_on(master, master_opts) do
  step "Expect the master to reject the request"
  on master, submit_bad_yaml_as_parameter, :acceptable_exit_codes => [CURL_UNABLE_TO_FETCH_PAGE]
end
